<?php
	require_once('../config/tce_config.php');
	$pagelevel = K_AUTH_IMPORT_USERS;
	require_once('../../shared/code/tce_authorization.php');
	$thispage_title = 'UNGGAH PENGGUNA';
	$thispage_title_icon = '<i class="fas fa-people-arrows"></i> ';
	require_once('../code/tce_page_header.php');
	require_once('../../shared/code/tce_functions_form.php');
	switch ($menu_mode) {
		case 'upload': {
			if($_FILES['userfile']['name']) {
				require_once('../code/tce_functions_upload.php');
				$uploadedfile = F_upload_file('userfile', K_PATH_CACHE);
				if($uploadedfile !== false) {
					switch ($file_type) {
						case 1: {
							$xmlimporter = new XMLUserImporter(K_PATH_CACHE.$uploadedfile);
							F_print_error('MESSAGE', $l['m_importing_complete']);
							break;
						}
						case 2: {
							if(F_import_tsv_users(K_PATH_CACHE.$uploadedfile)) {
								F_print_error('MESSAGE', $l['m_importing_complete']);
							}
							break;
						}
						case 3: {
							$new_filename = $uploadedfile.'_'.date('Y-m-d_H_i_s').'.tsv';
							require_once 'PHPExcel/Classes/PHPExcel/IOFactory.php';
							$excel = PHPExcel_IOFactory::load(K_PATH_CACHE.$uploadedfile);
							$writer = PHPExcel_IOFactory::createWriter($excel, 'CSV');
							$writer->setDelimiter("\t");
							$writer->setEnclosure("");
							$writer->save(K_PATH_CACHE.$new_filename);
							if(F_import_tsv_users(K_PATH_CACHE.$new_filename)) {
								F_print_error('MESSAGE', $l['m_importing_complete']);
							}
							break;
						}
					}
				}
			}
			break;
		}

		default: {
			break;
		}
	}
?>
<div class="container">
	<div class="tceformbox">
		<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post" enctype="multipart/form-data" id="form_importusers">
			<div class="row">
				<span class="label">
					<label for="userfile"><?php echo 'Pilih Berkas'; ?></label>
				</span>
				<span class="formw">
					<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo K_MAX_UPLOAD_SIZE ?>" />
					<input type="file" name="userfile" id="userfile" size="20" title="<?php echo $l['h_upload_file']; ?>" />
				</span>
				&nbsp;
			</div>
			<div class="row d-block">
				<div class="formw">
					<fieldset class="noborder">
						<legend title="<?php echo $l['h_file_type']; ?>"><?php echo 'Jenis Berkas'; ?></legend>
						<div class="mb-5">
							<input type="radio" name="file_type" id="file_type_xml" value="1" title="<?php echo $l['h_file_type_xml']; ?>" />
							<label for="file_type_xml">XML</label>
						</div>
						<div class="mb-5">
							<input type="radio" name="file_type" id="file_type_tsv" value="2" title="<?php echo $l['h_file_type_tsv']; ?>" />
							<label for="file_type_tsv">TSV</label>
						</div>
						<div class="mb-5 mt-10">
							<input type="radio" name="file_type" id="file_type_xlsx" value="3" checked="checked" title="<?php echo 'XLSX'; ?>" />
							<label for="file_type_xlsx">XLSX</label> <a href="../../template/watuskates_users_template.xlsx" class="bg-green p-5 brad-5 ft-white"><i class="fas fa-file-excel"></i> Unduh Template Pengguna</a>
						</div>
					</fieldset>
				</div>
			</div>
			<div class="row d-block">
				<?php
					F_submit_button("upload", 'UNGGAH', $l['h_submit_file']);
					echo F_getCSRFTokenField().K_NEWLINE;
				?>
			</div>
		</form>
	</div>
	<?php
		echo '<div class="pagehelp">'.'Penjelasan cara Unggah Pengguna adalah sebagai berikut: Siapkan (XML / TSV) atau unduh format (XLSX) berkas kemudian pilih jenis berkas yang sesuai dan unggah berkas yang sudah berisi data tersebut.'.'</div>'.K_NEWLINE;
		echo '</div>'.K_NEWLINE;
		require_once('../code/tce_page_footer.php');
		class XMLUserImporter {
		private $current_element = '';
		private $current_data = '';
		private $user_data = array();
		private $group_data = array();
		private $user_id = 0;
		private $xmlfile = '';
		public function __construct($xmlfile) {
			$this->xmlfile = $xmlfile;
			$this->parser = xml_parser_create();
			xml_set_object($this->parser, $this);
			xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, 0);
			xml_set_element_handler($this->parser, 'startElementHandler', 'endElementHandler');
			xml_set_character_data_handler($this->parser, 'segContentHandler');
			if(!xml_parse($this->parser, file_get_contents($xmlfile))) {
				die(sprintf(
					'ERROR xmlResourceBundle :: XML error: %s at line %d',
					xml_error_string(xml_get_error_code($this->parser)),
					xml_get_current_line_number($this->parser)
				));
			}
			xml_parser_free($this->parser);
		}
		public function __destruct() {
			@unlink($this->xmlfile);
		}
		private function startElementHandler($parser, $name, $attribs) {
			$name = strtolower($name);
			switch ($name) {
				case 'user': {
					$this->user_data = array();
					$this->group_data = array();
					$this->current_data = '';
					break;
				}
				case 'name':
				case 'password':
				case 'email':
				case 'regdate':
				case 'ip':
				case 'firstname':
				case 'lastname':
				case 'birthdate':
				case 'birthplace':
				case 'regnumber':
				case 'ssn':
				case 'level':
				case 'verifycode':
				case 'otpkey': {
					$this->current_element = 'user_'.$name;
					$this->current_data = '';
					break;
				}
				case 'group': {
					$this->current_element = 'group_name';
					$this->current_data = '';
					break;
				}
				default: {
					break;
				}
			}
		}
		private function endElementHandler($parser, $name) {
			global $l, $db;
			require_once('../config/tce_config.php');
			require_once('tce_functions_user_select.php');
			switch (strtolower($name)) {
				case 'name':
				case 'password':
				case 'email':
				case 'regdate':
				case 'ip':
				case 'firstname':
				case 'lastname':
				case 'birthdate':
				case 'birthplace':
				case 'regnumber':
				case 'ssn':
				case 'level':
				case 'verifycode':
				case 'otpkey': {
					$this->current_data = F_escape_sql($db, F_xml_to_text($this->current_data));
					$this->user_data[$this->current_element] = $this->current_data;
					$this->current_element = '';
					$this->current_data = '';
					break;
				}
				case 'group': {
					$group_name = F_escape_sql($db, F_xml_to_text($this->current_data));
					$sql = 'SELECT group_id
						FROM '.K_TABLE_GROUPS.'
						WHERE group_name=\''.$group_name.'\'
						LIMIT 1';
					if($r = F_db_query($sql, $db)) {
						if($m = F_db_fetch_array($r)) {
							$this->group_data[] = $m['group_id'];
						} else {
							$sqli = 'INSERT INTO '.K_TABLE_GROUPS.' (
								group_name
								) VALUES (
								\''.$group_name.'\'
								)';
							if(!$ri = F_db_query($sqli, $db)) {
								F_display_db_error(false);
							} else {
								$this->group_data[] = F_db_insert_id($db, K_TABLE_GROUPS, 'group_id');
							}
						}
					} else {
						F_display_db_error();
					}
					break;
				}
				case 'user': {
					if(!empty($this->user_data['user_name'])) {
						if(empty($this->user_data['user_regdate'])) {
							$this->user_data['user_regdate'] = date(K_TIMESTAMP_FORMAT);
						}
						if(empty($this->user_data['user_ip'])) {
							$this->user_data['user_ip'] = getNormalizedIP($_SERVER['REMOTE_ADDR']);
						}
						if(!isset($this->user_data['user_level']) or (strlen($this->user_data['user_level']) == 0)) {
							$this->user_data['user_level'] = 1;
						}
						if($_SESSION['session_user_level'] < K_AUTH_ADMINISTRATOR) {
							$this->user_data['user_level'] = min(max(0, ($_SESSION['session_user_level'] - 1)), $this->user_data['user_level']);
							if(empty($this->group_data)) {
								break;
							}
							$common_groups = array_intersect(F_get_user_groups($_SESSION['session_user_id']), $this->group_data);
							if(empty($common_groups)) {
								break;
							}
						}
						$sql = 'SELECT user_id,user_level
							FROM '.K_TABLE_USERS.'
							WHERE user_name=\''.$this->user_data['user_name'].'\'
								OR user_regnumber=\''.$this->user_data['user_regnumber'].'\'
								OR user_ssn=\''.$this->user_data['user_ssn'].'\'
							LIMIT 1';
						if($r = F_db_query($sql, $db)) {
							if($m = F_db_fetch_array($r)) {
								$user_id = $m['user_id'];
								if(($_SESSION['session_user_level'] >= K_AUTH_ADMINISTRATOR) or ($_SESSION['session_user_level'] > $m['user_level'])) {
									$sqlu = 'UPDATE '.K_TABLE_USERS.' SET
										user_regdate=\''.$this->user_data['user_regdate'].'\',
										user_ip=\''.$this->user_data['user_ip'].'\',
										user_name=\''.$this->user_data['user_name'].'\',
										user_email='.F_empty_to_null($this->user_data['user_email']).',';
									if(!empty($this->user_data['user_password'])) {
										$sqlu .= ' user_password=\''.F_escape_sql($db, getPasswordHash($this->user_data['user_password'])).'\',';
									}
									$sqlu .= '
										user_regnumber='.F_empty_to_null($this->user_data['user_regnumber']).',
										user_firstname='.F_empty_to_null($this->user_data['user_firstname']).',
										user_lastname='.F_empty_to_null($this->user_data['user_lastname']).',
										user_birthdate='.F_empty_to_null($this->user_data['user_birthdate']).',
										user_birthplace='.F_empty_to_null($this->user_data['user_birthplace']).',
										user_ssn='.F_empty_to_null($this->user_data['user_ssn']).',
										user_level=\''.$this->user_data['user_level'].'\',
										user_verifycode='.F_empty_to_null($this->user_data['user_verifycode']).',
										user_otpkey='.F_empty_to_null($this->user_data['user_otpkey']).'
										WHERE user_id='.$user_id.'';
									if(!$ru = F_db_query($sqlu, $db)) {
										F_display_db_error(false);
										return false;
									}
								} else {
									$this->group_data = array();
								}
							} else {
								$sqlu = 'INSERT INTO '.K_TABLE_USERS.' (
									user_regdate,
									user_ip,
									user_name,
									user_email,
									user_password,
									user_regnumber,
									user_firstname,
									user_lastname,
									user_birthdate,
									user_birthplace,
									user_ssn,
									user_level,
									user_verifycode,
									user_otpkey
									) VALUES (
									'.F_empty_to_null($this->user_data['user_regdate']).',
									\''.$this->user_data['user_ip'].'\',
									\''.$this->user_data['user_name'].'\',
									'.F_empty_to_null($this->user_data['user_email']).',
									\''.F_escape_sql($db, getPasswordHash($this->user_data['user_password'])).'\',
									'.F_empty_to_null($this->user_data['user_regnumber']).',
									'.F_empty_to_null($this->user_data['user_firstname']).',
									'.F_empty_to_null($this->user_data['user_lastname']).',
									'.F_empty_to_null($this->user_data['user_birthdate']).',
									'.F_empty_to_null($this->user_data['user_birthplace']).',
									'.F_empty_to_null($this->user_data['user_ssn']).',
									\''.$this->user_data['user_level'].'\',
									'.F_empty_to_null($this->user_data['user_verifycode']).',
									'.F_empty_to_null($this->user_data['user_otpkey']).'
									)';
								if(!$ru = F_db_query($sqlu, $db)) {
									F_display_db_error(false);
									return false;
								} else {
									$user_id = F_db_insert_id($db, K_TABLE_USERS, 'user_id');
								}
							}
						} else {
							F_display_db_error(false);
							return false;
						}
						if(!empty($this->group_data)) {
							foreach ($this->group_data as $key => $group_id) {
								$sqls = 'SELECT *
									FROM '.K_TABLE_USERGROUP.'
									WHERE usrgrp_group_id=\''.$group_id.'\'
										AND usrgrp_user_id=\''.$user_id.'\'
									LIMIT 1';
								if($rs = F_db_query($sqls, $db)) {
									if(!$ms = F_db_fetch_array($rs)) {
										$sqlg = 'INSERT INTO '.K_TABLE_USERGROUP.' (
											usrgrp_user_id,
											usrgrp_group_id
											) VALUES (
											'.$user_id.',
											'.$group_id.'
											)';
										if(!$rg = F_db_query($sqlg, $db)) {
											F_display_db_error(false);
											return false;
										}
									}
								} else {
									F_display_db_error(false);
									return false;
								}
							}
						}
					}
					break;
				}
				default: {
					break;
				}
			}
		}
		private function segContentHandler($parser, $data) {
			if(strlen($this->current_element) > 0) {
				$this->current_data .= $data;
			}
		}
	}
	function F_import_tsv_users($tsvfile) {
		global $l, $db;
		require_once('../config/tce_config.php');
		$tsvrows = file($tsvfile);
		if($tsvrows === false) {
			return false;
		}
		$nrows = count($tsvrows);
		for ($i = 1; $i < $nrows; $i++) {
			$rowdata = $tsvrows[$i];
			$userdata = explode("\t", $rowdata);
			if(empty($userdata[4])) {
				$userdata[4] = date(K_TIMESTAMP_FORMAT);
			}
			if(empty($userdata[5])) {
				$userdata[5] = getNormalizedIP($_SERVER['REMOTE_ADDR']);
			}
			if(!isset($userdata[12]) or (strlen($userdata[12]) == 0)) {
				$userdata[12] = 1;
			}
			if($_SESSION['session_user_level'] < K_AUTH_ADMINISTRATOR) {
				$userdata[12] = min(max(0, ($_SESSION['session_user_level'] - 1)), $userdata[12]);
				if(empty($userdata[15])) {
					break;
				}
				$usrgroups = explode(',', addslashes($userdata[15]));
				$common_groups = array_intersect(F_get_user_groups($_SESSION['session_user_id']), $usrgroups);
				if(empty($common_groups)) {
					break;
				}
			}
			$sql = 'SELECT user_id,user_level
				FROM '.K_TABLE_USERS.'
				WHERE user_name=\''.F_escape_sql($db, $userdata[1]).'\'
					OR user_regnumber='.F_empty_to_null($userdata[10]).'
					OR user_ssn='.F_empty_to_null($userdata[11]).'
				LIMIT 1';
			if($r = F_db_query($sql, $db)) {
				if($m = F_db_fetch_array($r)) {
					$user_id = $m['user_id'];
					if(($_SESSION['session_user_level'] >= K_AUTH_ADMINISTRATOR) or ($_SESSION['session_user_level'] > $m['user_level'])) {
						$sqlu = 'UPDATE '.K_TABLE_USERS.' SET
							user_name=\''.F_escape_sql($db, $userdata[1]).'\',';
						if(!empty($userdata[2])) {
							$sqlu .= ' user_password=\''.F_escape_sql($db, getPasswordHash($userdata[2])).'\',';
						}
						$sqlu .= '
							user_email='.F_empty_to_null($userdata[3]).',
							user_regdate=\''.F_escape_sql($db, $userdata[4]).'\',
							user_ip=\''.F_escape_sql($db, $userdata[5]).'\',
							user_firstname='.F_empty_to_null($userdata[6]).',
							user_lastname='.F_empty_to_null($userdata[7]).',
							user_birthdate='.F_empty_to_null($userdata[8]).',
							user_birthplace='.F_empty_to_null($userdata[9]).',
							user_regnumber='.F_empty_to_null($userdata[10]).',
							user_ssn='.F_empty_to_null($userdata[11]).',
							user_level=\''.intval($userdata[12]).'\',
							user_verifycode='.F_empty_to_null($userdata[13]).',
							user_otpkey='.F_empty_to_null($userdata[14]).'
							WHERE user_id='.$user_id.'';
						if(!$ru = F_db_query($sqlu, $db)) {
							F_display_db_error(false);
							return false;
						}
					} else {
						$userdata[15] = '';
					}
				} else {
					$sqlu = 'INSERT INTO '.K_TABLE_USERS.' (
						user_name,
						user_password,
						user_email,
						user_regdate,
						user_ip,
						user_firstname,
						user_lastname,
						user_birthdate,
						user_birthplace,
						user_regnumber,
						user_ssn,
						user_level,
						user_verifycode,
						user_otpkey
						) VALUES (
						\''.F_escape_sql($db, $userdata[1]).'\',
						\''.F_escape_sql($db, getPasswordHash($userdata[2])).'\',
						'.F_empty_to_null($userdata[3]).',
						\''.F_escape_sql($db, $userdata[4]).'\',
						\''.F_escape_sql($db, $userdata[5]).'\',
						'.F_empty_to_null($userdata[6]).',
						'.F_empty_to_null($userdata[7]).',
						'.F_empty_to_null($userdata[8]).',
						'.F_empty_to_null($userdata[9]).',
						'.F_empty_to_null($userdata[10]).',
						'.F_empty_to_null($userdata[11]).',
						\''.intval($userdata[12]).'\',
						'.F_empty_to_null($userdata[13]).',
						'.F_empty_to_null($userdata[14]).'
						)';
					if(!$ru = F_db_query($sqlu, $db)) {
						F_display_db_error(false);
						return false;
					} else {
						$user_id = F_db_insert_id($db, K_TABLE_USERS, 'user_id');
					}
				}
			} else {
				F_display_db_error(false);
				return false;
			}
			if(!empty($userdata[15])) {
				$groups = preg_replace("/[\r\n]+/", '', $userdata[15]);
				$groups = explode(',', addslashes($groups));
				foreach ($groups as $key => $group_name) {
					$group_name = F_escape_sql($db, $group_name);
					$sql = 'SELECT group_id
						FROM '.K_TABLE_GROUPS.'
						WHERE group_name=\''.$group_name.'\'
						LIMIT 1';
					if($r = F_db_query($sql, $db)) {
						if($m = F_db_fetch_array($r)) {
							$group_id = $m['group_id'];
						} else {
							$sqli = 'INSERT INTO '.K_TABLE_GROUPS.' (
								group_name
								) VALUES (
								\''.$group_name.'\'
								)';
							if(!$ri = F_db_query($sqli, $db)) {
								F_display_db_error(false);
								return false;
							} else {
								$group_id = F_db_insert_id($db, K_TABLE_GROUPS, 'group_id');
							}
						}
					} else {
						F_display_db_error(false);
						return false;
					}
					$sqls = 'SELECT *
						FROM '.K_TABLE_USERGROUP.'
						WHERE usrgrp_group_id=\''.$group_id.'\'
						AND usrgrp_user_id=\''.$user_id.'\'
						LIMIT 1';
					if($rs = F_db_query($sqls, $db)) {
						if(!$ms = F_db_fetch_array($rs)) {
							$sqlg = 'INSERT INTO '.K_TABLE_USERGROUP.' (
								usrgrp_user_id,
								usrgrp_group_id
								) VALUES (
								'.$user_id.',
								'.$group_id.'
								)';
							if(!$rg = F_db_query($sqlg, $db)) {
								F_display_db_error(false);
								return false;
							}
						}
					} else {
						F_display_db_error(false);
						return false;
					}
				}
			}
		}
		return true;
	}